package com.github.shynixn.structureblocklib.bukkit.api.business.service;

import org.bukkit.Location;
import org.bukkit.util.Vector;

/**
 * Created by Shynixn 2018.
 * <p>
 * Version 1.2
 * <p>
 * MIT License
 * <p>
 * Copyright (c) 2018 by Shynixn
 * <p>
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * <p>
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * <p>
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
public interface LocationCalculationService {
    /**
     * Converts the down and upCorner into a vector.
     *
     * @param downCorner downCorner
     * @param upCorner   upCorner
     * @return vector
     */
    Vector toDimensions(Location downCorner, Location upCorner);

    /**
     * Returns the location of the lowest corner.
     *
     * @param corner1 corner1
     * @param corner2 corner2
     * @return corner
     */
    Location getDownCornerLocation(Location corner1, Location corner2);

    /**
     * Returns the location of the upper corner.
     *
     * @param corner1 corner1
     * @param corner2 corner2
     * @return corner
     */
    Location getUpCornerLocation(Location corner1, Location corner2);
}
